import Component from '@glimmer/component';
import { tracked } from '@glimmer/tracking';
import { action } from '@ember/object';
import { precompileTemplate } from '@ember/template-compilation';
import { setComponentTemplate } from '@ember/component';

function _initializerDefineProperty(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}
function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object.keys(descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;
  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }
  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);
  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }
  if (desc.initializer === void 0) {
    Object.defineProperty(target, property, desc);
    desc = null;
  }
  return desc;
}

var TEMPLATE = precompileTemplate("<BasicDropdown\n  @disabled={{@disabled}}\n  @onOpen={{@onOpen}}\n  @onClose={{@onClose}}\n  @onFocus={{@onFocus}}\n  @destination={{@destination}}\n  @initiallyOpened={{@initiallyOpened}}\n  @horizontalPosition={{@horizontalPosition}}\n  @calculatePosition={{@calculatePosition}}\n  @verticalPosition={{@verticalPosition}}\n  @renderInPlace={{@renderInPlace}}\n  @matchTriggerWidth={{@matchTriggerWidth}}\n  ...attributes as |dd|>\n  <PowerCalendar\n    @htmlTag=\"\"\n    @center={{this.center}}\n    @locale={{@locale}}\n    @onCenterChange={{this.onCenterChange}}\n    @onSelect={{this.handleSelect}}\n    @selected={{@selected}} as |cal|>\n    {{#let (hash\n        uniqueId=dd.uniqueId\n        calendarUniqueId=cal.uniqueId\n        isOpen=dd.isOpen\n        disabled=dd.disabled\n\n        selected=cal.selected\n        loading=cal.loading\n        center=cal.center\n        locale=cal.locale\n\n        actions=(assign dd.actions cal.actions)\n      ) as |datepicker|}}\n      {{yield (assign\n        datepicker\n        (hash\n          Trigger=(component (ensure-safe-component dd.Trigger) dropdown=datepicker defaultClass=\"ember-power-datepicker-trigger\")\n          Content=(component (ensure-safe-component dd.Content) dropdown=datepicker defaultClass=\"ember-power-datepicker-content\")\n          Nav=(component (ensure-safe-component cal.Nav) calendar=datepicker)\n          Days=(component (ensure-safe-component cal.Days) calendar=datepicker)\n        )\n      )}}\n    {{/let}}\n  </PowerCalendar>\n</BasicDropdown>");

var _class, _descriptor;
var powerDatepicker = setComponentTemplate(TEMPLATE, (_class = class _class extends Component {
  constructor(...args) {
    super(...args);
    _initializerDefineProperty(this, "center", _descriptor, this);
  }
  get closeOnSelect() {
    return this.args.closeOnSelect !== undefined ? this.args.closeOnSelect : true;
  }
  onCenterChange(day) {
    if (this.args.onCenterChange) {
      this.args.onCenterChange(day);
    }
    this.center = day.date;
  }
  handleSelect(day, datepicker, e) {
    let value = this.args.onSelect(day, datepicker, e);
    if (value === false || !this.closeOnSelect) {
      return;
    }
    datepicker.actions.close();
  }
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, "center", [tracked], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class.prototype, "onCenterChange", [action], Object.getOwnPropertyDescriptor(_class.prototype, "onCenterChange"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "handleSelect", [action], Object.getOwnPropertyDescriptor(_class.prototype, "handleSelect"), _class.prototype)), _class));

export { powerDatepicker as default };
//# sourceMappingURL=power-datepicker.js.map
